/*[[[cog from arma_config_tools import *; json_to_arma()]]]*/
/*
    @author = "Aaron Clark - https://EpochMod.com";
    @contributors[] = {"Raimonds Virtoss","Andrew Gregory"};
    @description = "Custom Epoch Client Only functions";
    @licence = "Arma Public License Share Alike (APL-SA) - https://www.bistudio.com/community/licenses/arma-public-license-share-alike";
    @github = "https://github.com/EpochModTeam/Epoch/tree/release/Sources/epoch_config/Configs/CfgClientFunctions.hpp";
*/
class CfgClientFunctions
{
    version = 1;
    class A3E
    {
        tag = "EPOCH";
        file = "epoch_code\compile";
        class generic
        {
            file = "epoch_code\compile";
            class localCleanup {};
            class unitSpawnIncrease {};
            class unitSpawnDecrease {};
            class QuickTakeAll {};
            class QuickTakeLoad {};
            class effectCrypto {};
            class handleServerMessage {};
            class updateLoadingScreen {};
            class EnterBuilding {};
            class lootTrash {};
            class debugMonitor {};
            class interact {};
            class chopWood {};
            class fish {};
            class mineRocks {};
            class UnisexCheck {};
            class PutHandler {};
            class niteLight {};
            class LootIT {};
            class supportCopter {};
            class consumeItem {};
            class unitSpawn {};
            class onEachFrame {};
            class callSapperMigration {};
            class zombieSpawn {};
            class makeMarker {};
            class removeMarker {};
        };
        class building
        {
            class maintainIT {};
            class lockCheck {};
            class countdown {};
            class fnc_SelectTargetBuild {};
            class isBuildAllowed {};
            class simulSwap {};
            class staticMove {};
            class upgradeBUILD {};
            class removeBUILD {};
            class changeWallState {};
            class checkBuild {};
        };
        class traders
        {
            class startInteract {};
            class startInteractNPC {};
            class npcTraderAdd {};
            class npcTraderAdd2 {};
            class npcTraderAdd3 {};
            class startNPCTraderMenu {};
            class NPCTraderMenuFilter {};
            class startNpcTrade {};
            class tradeFilter {};
            class takeCrypto {};
            class startBankTransfer {};
        };
        class interface_event_handlers
        {
            class KeyDown {};
            class KeyUp {};
            class onChar {};
        };
        class event_handlers
        {
            class getInMan {};
            class getOutMan {};
        };
        class setup
        {
            class masterLoop {};
            class clientInit {};
            class clientRespawn {};
            class clientRevive {};
            class client_rejectPlayer {};
            class clientKeyMap {};
        };
        class p2p_trading
        {
            class startTRADEREQ {};
            class startTrade {};
            class tradeRequest {};
            class TradeLoop {};
            class makep2pTrade {};
        };
        class functions
        {
            class worldObjectType {};
            class returnConfig {};
            class returnConfigV2 {};
            class colorRange {};
            class convertTemp {};
            class fnc_playerDeath {};
            class fnc_playerFired {};
            class fnc_isInsideBuilding {};
            class fnc_Weather {};
            class fnc_findSafePos {};
            class fnc_addItemOverflow {};
            class pushCustomVar {};
            class itemData {};
            class itemPicture {};
            class itemDisplayName {};
            class SortArrayByDistance {};
            class fnc_findRandomPosBehind {};
            class fnc_stringLeft {};
            class fnc_findSapperStalkLocation {};
            class fnc_dirToFuzzy {};
            class fnc_cursorTarget {};
            class fnc_triggerAntagonist {};
            class fnc_playerDeathDetonate {};
            class fnc_playerDeathMorph {};
            class fnc_playerSetVariable {};
            class fnc_playerAttachToAntagonist {};
            class fnc_dynamicFSM {};
            class fnc_vectorDivide {};
            class giveAttributes {};
            class fnc_spawnEffects {};
            class fnc_arrayStringToBool {};
        };
        class environment
        {
            class client_earthQuake {};
            class client_loadAnimalBrain {};
            class client_bitePlayer {};
        };
        class vehicles
        {
            class client_repairVehicle {};
            class client_lockVehicle {};
            class client_fillVehicle {};
            class client_gearVehicle {};
        };
        class missions
        {
            class mission_accept {};
            class mission_cage_sapper {};
            class mission_returnObj {};
        };
        class inventory
        {
            class selectInventoryItem {};
            class itemInteractClick {};
            class itemInteractDblClick {};
            class uniformArmorCalc {};
            class gearArmorCalc {};
            class factorArmor {};
            class maxArmorInit {};
            class initUI {};
            class refeshUI {};
        };
        class messaging
        {
            file = "epoch_code\gui\scripts\messaging";
            class message {};
            class message_old1 {};
            class message_old2 {};
        };
        class looting
        {
            class spawnLoot {};
        };
        class gui
        {
            file = "epoch_code\gui\scripts";
            class onPause {};
            class showStats {};
            class 3DctrlPitchYaw {};
            class 3DctrlSpin {};
            class 3DctrlYaw {};
            class InterruptConfig {};
            class InterruptConfigActions {};
            class getIDC {};
            class guiObjHP {};
            class secureStorageHandler {};
            class genderSelection {};
            class getColorScheme {};
            class dragControl {};
        };
        class animations
        {
            file = "epoch_code\gui\scripts\animations";
            class 2DCtrlShake {};
			class 2DCtrlHeartbeat {};
        };
        class config
        {
            file = "epoch_code\gui\scripts\config";
            class config_keymap {};
        };
        class dynamenu
        {
            file = "epoch_code\gui\scripts\dynamenu";
            class dynamicMenu {};
            class dynamicMenuPopulate {};
            class dynamicMenuCleanup {};
        };
        class dynamicHUD
        {
            file = "epoch_code\gui\scripts\dynamicHUD";
            class dynamicHUD_adjust {};
            class dynamicHUD_loadSave {};
            class dynamicHUD_start {};
            class getHUDCtrl {};
        };
        class gui_craft
        {
            file = "epoch_code\gui\scripts\craftingv2";
            class crafting_animate {};
            class crafting_ctrl_collector {};
            class crafting_dev_toggle {};
            class crafting_getConfig {};
            class crafting_checkGear {};
            class crafting_checkNearby {};
            class crafting_checkResources {};
            class crafting_craft {};
            class crafting_progress {};
            class crafting_load {};
            class crafting_unload {};
            class crafting_LB_click {};
            class crafting_LB_defaults {};
            class crafting_LB_doubleClick {};
            class crafting_colorScheme {};
        };
        class group
        {
            file = "epoch_code\gui\scripts\group";
            class Group_invitePlayer {};
            class Group_BtnMod {};
            class Group_BtnInvite {};
            class Group_onLoad {};
            class Group_List {};
            class Group_Combo {};
            class Group_BtnLeave {};
            class Group_BtnKick {};
            class cGroup_groupText {};
            class cGroup_onLoad {};
            class cGroup_BtnCreate {};
            class iGroup_acceptInvite {};
            class iGroup_onLoad {};
            class iGroup_refresh {};
            class Group_update {};
        };
        class gui_inventory
        {
            file = "epoch_code\gui\scripts\inventory";
            class Inventory_Group {};
            class Inventory_iGroup {};
        };
        class gui_missions
        {
            file = "epoch_code\gui\scripts\missions";
            class mission_refresh {};
            class mission_description {};
        };
        class gui_postProcessing
        {
            file = "epoch_code\gui\scripts\post_process";
            class postprocessCreate {};
            class postprocessAdjust {};
            class postprocessDestroy {};
            class setDrunk {};
            class setRadiation {};
        };
        class worldToScreen
        {
            file = "epoch_code\gui\scripts\worldToScreen";
            class gui3DCooldown {};
            class gui3DCooldownEH {};
            class gui3DWorldPos {};
            class gui3DWorldPosEH {};
            class gui3DModelPos {};
            class gui3DModelPosEH {};
        };
    };
};

/*[[[end]]]*/
